
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>&quot;《算法导论》之‘图’&quot;：深度优先搜索、宽度优先搜索及连通分量 / 憋错料</title>

    <meta name="description" content="&quot;《算法导论》之‘图’&quot;：深度优先搜索、宽度优先搜索及连通分量 本文兼参考自&lt;算法导论&gt;及&lt;算法&gt;. 以前一直不能够理解深度优先搜索和广度优先搜索,总是很怕去碰它们,但经过阅读上边提到的两本书,豁然开朗,马上就能理解得更进一步.  1. 深度优先搜索  1.1 迷宫搜索 在&lt;算法&gt;这本书中,作者写了很好的一个故事.这个故事让我马上理解了深度优先搜索的思想. 如下图1-1所示,如何在这个迷宫中找到出路呢?方法见图1-2. 图1-1 等价的迷宫模型 探索迷宫而不迷路的一种古老办法(至少可以追溯到忒修斯和米诺陶的传说)叫做Tre ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">&quot;《算法导论》之‘图’&quot;：深度优先搜索、宽度优先搜索及连通分量</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>　　本文兼参考自《算法导论》及《算法》。</p>
<p>　　以前一直不能够理解深度优先搜索和广度优先搜索，总是很怕去碰它们，但经过阅读上边提到的两本书，豁然开朗，马上就能理解得更进一步。</p>
<h2>　&nbsp;1. 深度优先搜索</h2>
<h3>　 &nbsp;1.1 迷宫搜索</h3>
<p>　　在《算法》这本书中，作者写了很好的一个故事。这个故事让我马上理解了深度优先搜索的思想。</p>
<p>　　如下<strong>图1-1</strong>所示，如何在这个迷宫中找到出路呢？方法见<strong>图1-2</strong>.</p>
<p>　　<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nMjAxNS81NzA0NjAvMjAxNTA0LzI3MjIzMjQ4OTU4MjM1NS5wbmc=.jpg" /></p>
<p>　　图1-1 等价的迷宫模型</p>
<p>　　探索迷宫而不迷路的一种古老办法（至少可以追溯到忒修斯和米诺陶的传说）叫做<strong>Tremaux搜索</strong>，如下图所示。要探索迷宫中的所有通道，我们需要：</p>
<p>　　1）选择一条没有标记过的通道，在你走过的路上铺一条绳子；</p>
<p>　　2）标记所有你第一次路过的路口和通道；</p>
<p>　　3）当来到一个标记过的路口时，用绳子回退到上个路口；</p>
<p>　　4）当回退到的路口已没有可走的通道时继续回退。</p>
<p>　　绳子可以保证你总能找到一条出路，标记则能保证你不会两次经过同一条通道或同一个路口。</p>
<p>　　<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nMjAxNS81NzA0NjAvMjAxNTA0LzI3MjIzMzE4OTI3NzQzMy5wbmc=.jpg" /></p>
<p>　　图1-2 Tremaux探索</p>
<h3>　 &nbsp;1.2 深度优先搜索</h3>
<p>　　《算法》作者给出的Java代码如下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvQ29udHJhY3RlZEJsb2NrLmdpZg==.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvRXhwYW5kZWRCbG9ja1N0YXJ0LmdpZg==.jpg" /></p>

<pre> 1 public class DepthFirstSearch
 2 {
 3     private boolean[] marked;
 4     private int count;
 5
 6     public DepthFirstSearch(Graph G, int s)
 7     {
 8         marked = new boolean[G.V()];
 9         dfs(G, s);
10     }
11
12     private void dfs(Graph G, int v)
13     {
14         marked[v] = true;
15         count++;
16         for(int w : G.adj(v))
17         {
18             if(!marked[w])
19             {
20                 dfs(G, w);
21             }
22         }
23     }
24
25     public boolean marked(int w)
26     {
27         return marked[w];
28     }
29
30     public int count()
31     {
32         return count;
33     }
34 }</pre>
<p>DFS.java</p>
<p>　　具体例子如下图1-3：</p>
<p>　　<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nMjAxNS81NzA0NjAvMjAxNTA0LzI3MjI1MDM1NzU1OTE3Ni5wbmc=.jpg" /></p>
<p>　　图1-3 使用深度优先探索的轨迹，寻找所有和顶点0连通的顶点</p>
<h3>　 &nbsp;1.3 寻找路径</h3>
<p>　　《算法》作者给出的Java代码如下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvQ29udHJhY3RlZEJsb2NrLmdpZg==.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvRXhwYW5kZWRCbG9ja1N0YXJ0LmdpZg==.jpg" /></p>

<pre> 1 public class DepthFirstPaths
 2 {
 3     private boolean[] marked; // Has dfs() been called for this vertex?
 4     private int[] edgeTo; // last vertex on known path to this vertex
 5     private final int s; // source
 6     public DepthFirstPaths(Graph G, int s)
 7     {
 8         marked = new boolean[G.V()];
 9         edgeTo = new int[G.V()];
10         this.s = s;
11         dfs(G, s);
12     }
13
14     private void dfs(Graph G, int v)
15     {
16         marked[v] = true;
17         for (int w : G.adj(v))
18             if (!marked[w])
19             {
20                 edgeTo[w] = v;
21                 dfs(G, w);
22             }
23     }
24
25     public boolean hasPathTo(int v)
26     {
27         return marked[v];
28     }
29
30     public Iterable&lt;Integer&gt; pathTo(int v)
31     {
32         if (!hasPathTo(v)) return null;
33         Stack&lt;Integer&gt; path = new Stack&lt;Integer&gt;();
34         for (int x = v; x != s; x = edgeTo[x])
35             path.push(x);
36         path.push(s);
37         return path;
38     }
39 }</pre>
<p>DFS.java</p>
<p>　　<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nMjAxNS81NzA0NjAvMjAxNTA0LzI3MjMwNDEwNjMwMzEyNy5wbmc=.jpg" /></p>
<p>　　图1-4 pathTo(5)的计算轨迹</p>
<p>　　<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nMjAxNS81NzA0NjAvMjAxNTA0LzI3MjMwMzIwOTI3MjE3OS5wbmc=.jpg" /></p>
<p>　　图1-5 使用深度优先搜索的轨迹，寻找所有起点为0的路径</p>
<h2>　 2. 广度优先搜索</h2>
<h3>　 &nbsp;2.1 迷宫搜索</h3>
<p>　 &nbsp;深度优先搜索就好像是一个人在走迷宫，广度优先搜索则好像是一组人在一起朝各个方向走这座迷宫，每个人都有自己的绳子。当出现新的叉路时，可以假设一个探索者可以分裂为更多的人来搜索它们。当两个探索者相遇时，会合二为一（并继续使用先到达者的绳子）。如下图2-1：</p>
<p>　　<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nMjAxNS81NzA0NjAvMjAxNTA0LzI3MjMxMzU5NDI3NzI0Ni5wbmc=.jpg" /></p>
<p>　　图2-1 广度优先的迷宫搜索</p>
<h3>　 &nbsp;2.2 广度优先搜索</h3>
<p>　　《算法》作者给出的使用广度优先搜索查找图中的路径的Java代码如下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvQ29udHJhY3RlZEJsb2NrLmdpZg==.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvRXhwYW5kZWRCbG9ja1N0YXJ0LmdpZg==.jpg" /></p>

<pre> 1 public class BreadthFirstPaths
 2 {
 3     private boolean[] marked;     // Is a shortest path to this vertex known?
 4     private int[] edgeTo;         // last vertex on known path to this vertex
 5     private final int s;         // source
 6
 7     public BreadthFirstPaths(Graph G, int s)
 8     {
 9         marked = new boolean[G.V()];
10         edgeTo = new int[G.V()];
11         this.s = s;
12         bfs(G, s);
13     }
14
15     private void bfs(Graph G, int s)
16     {
17         Queue&lt;Integer&gt; queue = new Queue&lt;Integer&gt;();
18         marked[s] = true;     // Mark the source
19         queue.enqueue(s);     // and put it on the queue.
20         while (!q.isEmpty())
21         {
22             int v = queue.dequeue();     // Remove next vertex from the queue.
23             for (int w : G.adj(v))
24             if (!marked[w])             // For every unmarked adjacent vertex,
25             {
26                 edgeTo[w] = v;             // save last edge on a shortest path,
27                 marked[w] = true;         // mark it because path is known,
28                 queue.enqueue(w);         // and add it to the queue.
29             }
30         }
31     }
32
33     public boolean hasPathTo(int v)
34     {
35         return marked[v];
36     }
37
38     public Iterable&lt;Integer&gt; pathTo(int v)
39     // Same as for DFS.
40 }</pre>
<p>BFS.java</p>
<p>　　一个例子如下：</p>
<p>　　<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nMjAxNS81NzA0NjAvMjAxNTA0LzI3MjMyNTIwNDc0ODk4My5wbmc=.jpg" /></p>
<p>　　图2-2 使用广度优先搜索寻找所有起点为0的路径的结果</p>
<p>　　<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nMjAxNS81NzA0NjAvMjAxNTA0LzI3MjMyNTMwOTc0NDE3NS5wbmc=.jpg" /></p>
<p>　　图2-3 使用广度优先搜索的轨迹，寻找所有起点为0的路径</p>
<h2>　 3. 连通分量</h2>
<p>　　具体代码已经托管到<a href="https://github.com/xiehongfeng100/DataStructures-and-Algorithms/tree/master/Graph" rel="external nofollow noreferrer">Github</a>.</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 08:31:45 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>&quot;《算法导论》之‘图’&quot;：深度优先搜索、宽度优先搜索及连通分量的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NGB1oM.html" rel="bookmark">挑战程序2&period;1&period;5 穷竭搜索&amp;gt&semi;&amp;gt&semi;宽度优先搜索（练POJ3669）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				先对比一下DFS和BFS         深度优先搜索DFS                                   宽度优先搜索BFS 明显可以看出搜索顺序不同. DFS是搜索单条路径到底部,再回溯. BFS是搜索近的状态,直到底部,一般在求解最短路径或者最短步数上应用. BFS要用到队列呢.. 队列的用法看一看http://blog.csdn.net/cindywry/article/details/51919282 练习题系列--------------------- 题目:p			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eZXnD3.html" rel="bookmark">基础算法 --- BFS（广度优先搜索&sol;宽度优先搜索）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				个人理解 BFS是一种最简便的图搜索算法,通过遍历整张图直到找到目标节点: 从算法的角度看,所有因为展开节点而得到的字节点会被存储到一个FIFO的数据结构中,被遍历过的节点存储在一个容器中(一般是一个set),防止重复搜索 图解 如图所示,我们想要获取从S到E节点的最短路径,运用BFS,如何处理?? 主要思想是:从节点S开始将其所有临近子节点存放到一个队列中,然后标记这些节点到最初顶点S的距离为1: 然后根据队列的先进先出特定,出队列,判断是否为目标节点:如果不是,将出队节点的临近子节点入队,直			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0RYyXPM.html" rel="bookmark">算法7-4：宽度优先搜索</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				宽度优先搜索的基本思想就是先将源点添加到一个队列中, 每次从队列中取出一个顶点,将该顶点的邻居顶点中没有拜访过的顶点都添加到队列中,最后直到队列消耗完毕为止. 应用 宽度优先搜索可以解决最短路径问题.而最短路径算法在互联网中应用非常广泛,尤其是路由这块.因为路由追求的是高效,所以每个路由路径都是通过最短路径计算出来的.如果没有最短路径算法,我们可能就享受不到这么快的网速了. 另外,宽度优先搜索在快递行业也会用到,用于计算最短路径. 代码 import java.util.Stack; /** *			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0d7ezrM.html" rel="bookmark">广度&sol;宽度优先搜索&lpar;BFS&rpar;详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				广度/宽度优先搜索(BFS) [算法入门] 1.前言 广度优先搜索(也称宽度优先搜索,缩写BFS,以下采用广度来描述)是连通图的一种遍历策略.因为它的思想是从一个顶点V0开始,辐射状地优先遍历其周围较广的区域,故得名. 一般可以用它做什么呢?一个 广度/宽度优先搜索(BFS) 算法导论里边会给出不少严格的证明,我想尽量写得通俗一点,因此采用一些直观的讲法来伪装成证明,关键的point能够帮你get到就好. 2.图的概念 刚刚说的广度优先搜索是连通图的一种遍历策略,那就有必要将图先简单解释一下.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0nvar70.html" rel="bookmark">宽度优先搜索</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Breadth First Search 宽度优先搜索算法(又称广度优先搜索)是最简便的图的搜索算法之一,这一算法也是很多重要的图的算法的原型.Dijkstra单源最短路径算法和Prim最小生成树算法都采用了和宽度优先搜索类似的思想.其别名又叫BFS,属于一种盲目搜寻法,目的是系统地展开并检查图中的所有节点,以找寻结果.换句话说,它并不考虑结果的可能位置,彻底地搜索整张图,直到找到结果为止. 与树的层序遍历一样 遍历结果为 1 2 3 4 5 6 .....21 22 操作: 根节点入队: wh			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0je7KAM.html" rel="bookmark">层层递进&mdash;&mdash;宽度优先搜索（BFS）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题引入 我们接着上次“解救小哈”的问题继续探索,不过这次是用宽度优先搜索(BFS). 注:问题来源可以点击这里 http://www.cnblogs.com/OctoptusLian/p/7429645.html 最开始小哼在入口(1,1)处,一步之内可以到达的点有(1,2)和(2,1). 但是小哈并不在这两个点上,那小哼只能通过(1,2)和(2,1)这两点继续往下走. 比如现在小哼走到了(1,2)这个点,之后他又能够到达哪些新的点呢?有(2,2).再看看通过(2,1)又可以到达哪些点呢?可以			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDoy2Y4.html" rel="bookmark">（总结）宽度优先搜索（Breadth First Search）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ACM入门最经典的开局一般都是宽搜. 宽度优先搜索(以下均简称bfs)一般用于树和图的搜索,在ACM中属于比较基础的技巧,因此需要非常熟练的掌握. 那么从最基础的bfs开始讲起.在一个迷宫中,有一个起点和一个终点(出口),和一些障碍物(无法通过). 比如下图			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0RBeK90.html" rel="bookmark">宽度优先搜索（BFS）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				宽度优先搜索,又称为广度优先搜索,简称BFS 搜索过程:从初始结点开始,逐层向下扩展,即第n层搜索未完成,不得进入下一层搜索 一.初始结点入队,进入循环 二.取出队列的第一个元素 三.判断该结点是不是目标结点,如果是目标结点,则问题解决,跳出循环 四.如果该结点不是目标结点,判断其是否能够扩展,若不能,跳到步骤二 五.如果该结点能扩展,将其子结点放入队列的尾部 六.跳到步骤二 用一个经典的例子(走迷宫)来感受下 给定一个二维数组 int a[10][10] = {0 , 1 , 0 , 0 ,			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02qmzDM.html" rel="bookmark">算法导论22&period;3深度优先搜索 练习总结 （转载）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				22.3-1 画一个 3*3 的网格,行和列的抬头分别标记为白色.灰色和黑色,对于每个表单元 (i, j),请指出对有向图进行深度优先搜索的过程中,是否可能存在一条边,链接一个颜色为 i 的结点和一个颜色为 j 的结点.对于每种可能的边,指明该种边的类型.另外,请针对无向图的深度优先搜索再制作一张这样的网格. ANSWER:   22.3-2 给出深度优先搜索算法在图 22-6 上的运行过程.假定深度优先搜索算法的第 5~7 行的 for 循环是以字母表顺序依次处理每个结点,假定每条邻接链表皆以			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/j4NKXZM.html" rel="bookmark" class="title">框架模块设计经验总结</a>
					<div>
						转自:http://www.cnblogs.com/zgynhqf/archive/2011/07/15/2107593.html 这是原创,尊重原创............ 框架模块设计经验总结 三 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Q0xmPn3.html" rel="bookmark" class="title">form里面文件上传并预览</a>
					<div>
						其实form里面是不能嵌套form的,如果form里面有图片上传和其他input框,我们希望上传图片并预览图片,然后将其他input框填写完毕,再提交整个表单的话,有两种方式! 方式一:点击上传按钮的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoQk5Q3.html" rel="bookmark" class="title">让Chrome可以修改字体</a>
					<div>
						在chrome地址栏输入chrome://flags/ , 然后将&quot;停用DirectWrite Windows&quot;改为停用 , 这样自定义的字体就可以生效了.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35qqJn3.html" rel="bookmark" class="title">myeclipse新建jsp文件时弹出默认模板&comma;怎么改成自己修改后的</a>
					<div>
						(1)打开Window--Preferences (2)选择MyEclipse--Filed andEditors--JSP--JSP Source--Templates 看到右边的New Jsp编辑 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dAlB63.html" rel="bookmark" class="title">需要注意学习&period;net过程的要点</a>
					<div>
						基础部分 C# 基础语法 OOP的概念,面向对象的理解 继承 封装 多态 ASP.NET MVC (Web Form 用的越来越少,如果你不熟悉,可以不看) JavaScript 基础语法 如何在HT ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MomBVx3.html" rel="bookmark" class="title">Constraints on a Wildcard &colon; Generic Parameters</a>
					<div>
						public static void saveAll(LinkedList&lt;? extends java.io.Serializable&gt; list) { } public static  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmoGAP3.html" rel="bookmark" class="title">【JavaScript学习】-JavaScript内置对象1-对象概述</a>
					<div>
						对象(object): JavaScript 中的所有事物都是对象,如:字符串.数值.数组.函数等,每个对象带有属性和 方法.JavaScript 提供多个内建对象,比如 String.Date.Ar ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xvKKB4.html" rel="bookmark" class="title">bash脚本（三）&lowbar;函数</a>
					<div>
						函数:功能 function. 作用:代码重用. 函数的定义: 1.使用function关键字. function FUNNAME { COMMAND ... } 2.使用FUNNAME() FUNN ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyWOqA3.html" rel="bookmark" class="title">你所不知道的几个经济学真相</a>
					<div>
						最近研究了一下经济学,用程序员的严密逻辑思维来观察,发现一些惊人的事实: 1.GDP=产量*单价,产量没变,单价上涨,GDP也会上涨. 2.为了防止失业,也就是让国民有活干,就要增加需求,表面上向市场 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l7R9XM.html" rel="bookmark" class="title">多语言处理</a>
					<div>
						在学习如何使用.NET资源文件以及如何开发World-Ready程序之前,我们先通过一个例子来看看为什么要使用资源文件,以及使用它的好处. 假设要在程序中根据当前的Culutre来设置Form的Tit ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzEbqW4.html" rel="bookmark" class="title">vb中的封装，继承，多态的实现。</a>
					<div>
						        VB中引入了面向对象的编程机制,使该语言具有面向对象语言的封装.继承和多态三个主要的特征,极大地提高了应用程序的开发效率.但是大多数面向对象的设计语言都通过继承来提供多态的,而vb是通 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02yn6zM.html" rel="bookmark" class="title">SQL多表联查总结</a>
					<div>
						交叉连接:(不常用)返回两个表的笛卡尔乘积(也即全组合排列)中符合查询条件的数据行. 内连接返回连接表中符合连接条件和查询条件的数据行. 左外连接返回符合连接条件和查询条件(即:内连接)的数据行,且还 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rBzP13.html" rel="bookmark" class="title">【组队训练】2013天津区域赛</a>
					<div>
						三题,按现场排名应该是80名,铜牌靠后. 几次训练发现自己的心理素质实在是太!差!了!一开始,老规矩,我k题,zrA题,ysB题. A题大模拟,比较费时,zr先看了过了几个人的H,31mins,1A  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OynGXM.html" rel="bookmark" class="title">WEB 开发所用的网站</a>
					<div>
						常用前端手册: http://caniuse.com/ http://www.w3school.com.cn/ http://www.runoob.com/ http://www.css88.com/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3Zpdp8M.html" rel="bookmark" class="title">loadrunner脚本中参数化和返回值输出log到外部文件</a>
					<div>
						loadrunner脚本中参数化和返回值输出log到外部文件 很多时候,我们在做性能测试之前,需要造数据,但是使用的这些参数化数据和生成的返回数据在后面的测试都会用的,所以我们需要在造数据过程中,将参 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NyL1G3.html" rel="bookmark" class="title">（转）Oracle各个服务的用处</a>
					<div>
						Oracle10g安装后,一般会有如下几个服务: 1.OracleCSService 主要是通过控制集群结点的成员以及通知这些成员这个结点是什么时候加入和离开的,OracleCSService服务通过 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3v1YDL0.html" rel="bookmark" class="title">Array&period;prototype&period;map&lpar;&rpar;</a>
					<div>
						map() 方法创建一个新数组,其结果是该数组中的每个元素调用一个提供的函数. let numbers = [1, 5, 10, 15]; let roots = numbers.map(functi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47zZJY3.html" rel="bookmark" class="title">《数据结构》C&plus;&plus;代码 BFS与DFS</a>
					<div>
						       BFS,广度优先搜索,一层一层去遍历图,故称广度优先.实现方式:队列.        DFS,深度优先搜索,撞墙才回头的遍历,称为深度优先.实现方式:递归(栈).        这两种遍 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0k6PRjM.html" rel="bookmark" class="title">SICP学习笔记及题解&mdash;构造过程抽象&lpar;三&rpar;</a>
					<div>
						主要内容 高阶过程:以过程为参数和/或返回值的过程 lambda 表达式 let 表达式 用过程作为解决问题的通用方法 求函数的 0 点 求函数的不动点 返回过程值 过程是语言里的一等公民 (firs ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXG9Ak4.html" rel="bookmark" class="title">jQuery &dollar;&lpar;document&rpar;&period;ready&lpar;&rpar;和JavaScript onload事件</a>
					<div>
						对元素的操作和事件的绑定需要等待一个合适的时机,可以看下面的例子: &lt;!DOCTYPE html&gt; &lt;meta charset=&quot;utf-8&quot;&gt; &lt;h ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.021 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
